class volture
 {
 	private:
 	 enum { _COL=19, _ROW=2, _XPIX=62, _YPIX=46 };
 	 int start_x,start_y,pos_x,pos_y,scroll_x,scroll_y,jump_y,_X,_Y,_i;
 	 int plat_y,plat_stair,plat_wall;
 	 int energy;
 	 int dx,dy;
 	 int act_frame;
 	 bool can_hit,hittable;
 	 bool side,direction; // posizione speculare e direzione di moto 0 = destra, 1 = sinistra
 	 bool active,stop,move,jump_up,jump_down,down,climb,fire1,fire2,fire_down,fire_up,fall,hitted,fly,dead,explode;
 	 timer *ti[5];
 	 SAMPLE *sound[4];
 	 BITMAP *frame[_COL*_ROW];
 	 BITMAP *frame_col[_COL*_ROW];
 	 BITMAP *out;
 	 map *plat_map;
 	 map *hight_map;
 	 map *back_map;

 	 void loadSpriteFrames(char *);
 	 void assignSpriteFrame(volture *);
 	 void setOutBitmap(BITMAP *);
 	
 	public:
 	 volture(char *,int,int,BITMAP *,int i=0,volture *p=NULL);
 	 ~volture();
 	 void setStartX(int);
 	 void setStartY(int);
 	 bool isActive();
 	 void drawSprite(int,int);
 	 void timeSprite();
 	 void platformSprite();
 	 void animSprite();
 	 void setPlatformMap(map *p);
 	 void setHightMap(map *p);
 	 void setBackgroundMap(map *p);
 	 void loadSample(char *,int);
 	 void assignSample(int,volture *);
 	 BITMAP *getActFrameColP();
 	 bool inScreen();
   void setHitted(bool b);
   bool canHit();
   bool isHittable();
 	 int getPlatYPos();
 	 int getPosX();
 	 int getPosY();
 	 int getScore();
 	 int *getPosXP();
 	 int *getPosYP();
 	 void resetObj(bool);
 	 void debug();
 };

volture::volture(char *filename, int sx, int sy, BITMAP *out, int i, volture *p)
 {
 	_i=i;
 	if(!_i) loadSpriteFrames(filename); else assignSpriteFrame(p);
 	setOutBitmap(out);
 	start_x=sx; start_y=sy;
  resetObj(true);
 	ti[0]=new timer(4);  // Anim time
 	ti[1]=new timer(2);  // Explode time
 	ti[2]=new timer(5);  // Stop time
 	ti[3]=new timer(10); // Fly anim time
 	ti[4]=new timer(0);
 }

volture::~volture()
 {
 	for(int i=0;i<5;i++) delete(ti[i]);
 	if(_i==0)
 	 {
    for(int i=0;i<2;i++)    destroy_sample(sound[i]);
 	  for(int i=0;i<_COL*_ROW;i++) destroy_bitmap(frame[i]);
 	  for(int i=0;i<_COL*_ROW;i++) destroy_bitmap(frame_col[i]);
 	 }
 }

void volture::loadSpriteFrames(char *filename)
 {
 	BITMAP *aux;

  aux=load_bmp(filename,NULL);
  //for(int i=0;i<_COL;i++) frame[i]=create_sub_bitmap(aux,46*i+i,0,46,46);
  for(int i=0;i<_ROW;i++)
   for(int j=0;j<_COL;j++)
    {
     //frame[j+_COL*i]=create_sub_bitmap(aux,46*j+j,46*i+i,46,46);
     frame[j+_COL*i]=create_bitmap(_XPIX,_YPIX);
     blit(aux,frame[j+_COL*i],_XPIX*j+j,_YPIX*i+i,0,0,frame[j+_COL*i]->w,frame[j+_COL*i]->h);
     frame_col[j+_COL*i]=create_bitmap_ex(8,_XPIX,_YPIX);
     clear_to_color(frame_col[j+_COL*i],0);
     for(int h=0;h<frame[j+_COL*i]->h;h++)
      for(int w=0;w<frame[j+_COL*i]->w*4;w+=4)
       if(makecol32(frame[j+_COL*i]->line[h][w+2],
                    frame[j+_COL*i]->line[h][w+1],
                    frame[j+_COL*i]->line[h][w])!=16711935)
        frame_col[j+_COL*i]->line[h][w>>2]=1;
    }
  destroy_bitmap(aux);
 }

void volture::assignSpriteFrame(volture *p)
 {
 	for(int i=0;i<_ROW*_COL;i++)
 	 {
 	  frame[i]=p->frame[i];
 	  frame_col[i]=p->frame_col[i];
 	 }
 }

void volture::loadSample(char *filename, int n)
 {
 	sound[n]=load_sample(filename);
 }

void volture::assignSample(int n,volture *p)
 {
 	sound[n]=p->sound[n];
 }

void volture::setOutBitmap(BITMAP *bmp) { out=bmp; }

void volture::timeSprite()
 {
 	for(int i=0;i<5;i++) ti[i]->time();
 }

void volture::animSprite()
 {
 	if(!active) return;
 	if(dead) return;
 	if(explode) 
 	 {
 	 	if(ti[1]->isOn()) act_frame++;
 	 	if(act_frame==35)
 	 	 {
 	 	  act_frame=35;
 	 	  explode=0;
 	 	  dead=1;
 	 	 }
 	 	return;
 	 }
 	if(!fly) if(random(2)==1) fly=1;
 	if(fly)  { if(side) dx=-2; else dx=2; if(ti[3]->isOn()) { act_frame++; if(act_frame>2) act_frame=1; } }
 	if(hitted) { play_sample(sound[0],120,150,1000,0); hitted=0; act_frame=19; stop=1; energy--; if(energy==0) { explode=1; fly=0; stop=0; play_sample(sound[1],120,150,1000,0); } else explode=0; ti[2]->reset(); return; }
 	if(stop) { dx=0; act_frame=19; if(ti[2]->isOn()) stop=0; }
 	pos_x+=dx;
 	pos_y+=dy;
 	/*if(climb) // Sulla scala
 	 {
    if(key[KEY_UP])           { pos_y-=2; }
    if(key[KEY_DOWN])         { pos_y+=2; }
    if(plat_stair==0)         { climb=0; }
    jump_up=0; jump_down=0; fire1=0; fire2=0; fire_down=0; fire_up=0;
    return;
 	 }
 	if(!jump_up && !jump_down && !fire1 && !fire2 && !fire_down && !fire_up && !climb) // Al suolo
 	 {
    if(!key[KEY_LEFT])        { move=0; stop=1; }
    if(!key[KEY_RIGHT])       { move=0; stop=1; }
    if(!key[KEY_DOWN])        { down=0; stop=1; }
    if(key[KEY_LEFT]  && !key[KEY_RIGHT]) { move=1; down=0; stop=0; if(!side) turn=1; direction=1; dx=-2; }
    if(key[KEY_RIGHT] && !key[KEY_LEFT])  { move=1; down=0; stop=0; if(side)  turn=1; direction=0; dx=2;  }
    if(key[KEY_LEFT]  &&  key[KEY_RIGHT]) { move=1; down=0; stop=0; if(side)  turn=1; direction=0; dx=2;  }
    if(key[KEY_UP] &&
       plat_stair==1)         { climb=1; stop=0; move=0; act_frame=18; plat_map->setScrollX((plat_map->getActTileX()-6)*plat_map->getTileW()+8); hight_map->setScrollX(plat_map->getScrollX()); back_map->setScrollX(plat_map->getScrollX()/2); }
    if(key[KEY_DOWN])         { 
    	                          if(plat_stair==2) { climb=1; stop=0; move=0; act_frame=23; plat_map->setScrollX((plat_map->getActTileX()-6)*plat_map->getTileW()+8); hight_map->setScrollX(plat_map->getScrollX()); back_map->setScrollX(plat_map->getScrollX()/2); }
    	                          else { down=1; move=0; stop=0; }
    	                        }
    if(key[KEY_ALT] && !fall) { jump_up=1; down=0; dy=-4; key[KEY_ALT]=0; jump_y=0;}
    if(key[KEY_LCONTROL])     { 
    											     move=0; stop=0;
    											     if(!down)       { fire1=1; fire2=0; fire_up=0; act_frame=10; }
    											     if(down)        { fire2=1; fire1=0; fire_up=0; act_frame=12; }
    											     if(key[KEY_UP]) { fire_up=1; fire1=0; fire2=0; act_frame=14; }
    	                         down=0;
    	                         play_sample(sound[0],120,150,1000,0);
    	                         key[KEY_LCONTROL]=0;
    	                        }
   }
  if((jump_up || jump_down) && !fire1 && !fire2 && !fire_down && !fire_up && !climb) // In volo
 	 {
    if(!key[KEY_LEFT])    { stop=1; }
    if(!key[KEY_RIGHT])   { stop=1; }
    if(!key[KEY_DOWN])    { down=0; stop=1; }
    if(key[KEY_LEFT]  && !key[KEY_RIGHT]) { if(!side) turn=1; }
    if(key[KEY_RIGHT] && !key[KEY_LEFT])  { if(side)  turn=1; }
    if(key[KEY_LEFT]  &&  key[KEY_RIGHT]) { if(side)  turn=1; }
    if(key[KEY_UP])       { }
    if(key[KEY_DOWN])     { }
    if(key[KEY_ALT])      { key[KEY_ALT]=0; }
    if(key[KEY_LCONTROL]) { 
    											 stop=0;
    											 if(!down)         { fire1=1; fire2=0; fire_up=0; fire_down=0; act_frame=10; }
    											 if(down)          { fire2=1; fire1=0; fire_up=0; fire_down=0; act_frame=12; }
    											 if(key[KEY_UP])   { fire_up=1; fire1=0; fire2=0; fire_down=0; act_frame=14; }
    											 if(key[KEY_DOWN]) { fire_down=1; fire_up=1; fire1=0; fire2=0; act_frame=16; }
    	                     down=0;
    	                     play_sample(sound[0],120,150,1000,0);
    	                     key[KEY_LCONTROL]=0;
    	                    }
   }*/
 }

void volture::drawSprite(int sx,int sy)
 {
 	if(!active) return;
  //pivot_sprite(rend,car,rend_x,rend_y,piv_cx,piv_cy,itofix(ang1));
  _X=-sx+pos_x-30; _Y=-sy+pos_y-12;
  if((act_frame>=0 && act_frame<3) || act_frame==19) can_hit=true; else can_hit=false;
  if(act_frame<3 || act_frame==19) hittable=true; else hittable=false;
  if(inScreen())
   {
    if(side) draw_sprite_h_flip(out,frame[act_frame],_X,_Y);
    else     draw_sprite       (out,frame[act_frame],_X,_Y);
   }
 }

void volture::platformSprite()
 {
 	if(!active) return;
 	if(!jump_down && !jump_up && !climb)
 	{
 	 if(pos_y>plat_y) if(pos_y-plat_y<=8) pos_y=plat_y; 
 	 if(pos_y<plat_y) if(plat_y-pos_y<=8) pos_y=plat_y; 
 	 if(pos_y<plat_y) { fall=1; dy++; dx=0; } else { fall=0; dy=0; }
 	}
 	//plat_y=plat_map->getActPlatform();
 	plat_wall=0;//plat_map->getActWall(direction);
 	plat_stair=0;//plat_map->getActStair();
 }

BITMAP *volture::getActFrameColP() { return frame_col[act_frame]; }

bool volture::inScreen()
 {
 	if(_X>=-62 && _X<=384) return true;
 	else return false;
 }

int volture::getPlatYPos() { return plat_y; }

int volture::getPosX() { return _X; }

int volture::getPosY() { return _Y; }

int *volture::getPosXP() { return &pos_x; }

int *volture::getPosYP() { return &pos_y; }

int volture::getScore() { if(energy==1) return 200; else return 0; }

void volture::setPlatformMap(map *p) { plat_map=p; }

void volture::setHightMap(map *p) { hight_map=p; }

void volture::setBackgroundMap(map *p) { back_map=p; }

void volture::setHitted(bool b) { hitted=b; }

bool volture::canHit() { return can_hit; }

bool volture::isHittable() { return hittable; }

bool volture::isActive() { return active; }

void volture::setStartX(int sx) { start_x=sx; }

void volture::setStartY(int sy) { start_y=sy; }

void volture::resetObj(bool act)
 {
 	active=act;
 	pos_x=start_x; pos_y=start_y; scroll_x=0; scroll_y=0; jump_y=0;
 	energy=2;
 	dx=0; dy=0; plat_y=start_y;
 	act_frame=1;
 	stop=0; move=0; jump_up=0; jump_down=0; down=0; climb=0; fire1=0; fire2=0; fire_down=0,fire_up=0,fall=0,hitted=0,fly=0,dead=0,explode=0;
 	side=1; direction=0;
 }

void volture::debug()
 {
 	putpixel(out,pos_x,pos_y-30+58,makecol32(255,0,0));
  putpixel(out,pos_x,pos_y-30+59,makecol32(255,0,0));
  putpixel(out,pos_x,pos_y-30+60,makecol32(255,0,0));
  putpixel(out,pos_x,pos_y-30+61,makecol32(255,0,0));
  putpixel(out,pos_x,pos_y-30+62,makecol32(255,0,0));
  putpixel(out,pos_x-2,pos_y-30+60,makecol32(255,0,0));
  putpixel(out,pos_x+2,pos_y-30+60,makecol32(255,0,0));
  putpixel(out,pos_x-1,pos_y-30+61,makecol32(255,0,0));
  putpixel(out,pos_x+1,pos_y-30+61,makecol32(255,0,0));
 }
